(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('sq-single-angular-modal')) :
        typeof define === 'function' && define.amd ? define(['exports', '@angular/core', 'sq-single-angular-modal'], factory) :
            (factory((global.angular2Modal = global.angular2Modal || {}, global.angular2Modal.plugins = global.angular2Modal.plugins || {}, global.angular2Modal.plugins.jsNative = global.angular2Modal.plugins.jsNative || {}), global.ng.core, global.angular2Modal));
}(this, (function (exports, _angular_core, sqSingleAngularModal) {
    'use strict';
    var __extends$2 = (undefined && undefined.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DEFAULT_SETTERS = [
        'promptDefault'
    ];
    var JSNativeModalContext = (function (_super) {
        __extends$2(JSNativeModalContext, _super);
        function JSNativeModalContext() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        JSNativeModalContext.prototype.normalize = function () {
            if (!this.message)
                this.message = '';
            if (this.dialogType === undefined)
                this.dialogType = sqSingleAngularModal.DROP_IN_TYPE.alert;
        };
        return JSNativeModalContext;
    }(sqSingleAngularModal.ModalOpenContext));
    var JSNativeModalContextBuilder = (function (_super) {
        __extends$2(JSNativeModalContextBuilder, _super);
        function JSNativeModalContextBuilder(defaultValues, initialSetters, baseType) {
            if (defaultValues === void 0) {
                defaultValues = undefined;
            }
            if (initialSetters === void 0) {
                initialSetters = undefined;
            }
            if (baseType === void 0) {
                baseType = undefined;
            }
            return _super.call(this, defaultValues || {}, sqSingleAngularModal.arrayUnion(DEFAULT_SETTERS, initialSetters || []), baseType || JSNativeModalContext
            // https://github.com/Microsoft/TypeScript/issues/7234
            ) || this;
        }
        return JSNativeModalContextBuilder;
    }(sqSingleAngularModal.ModalOpenContextBuilder));
    var JSNativeModalRenderer = (function () {
        function JSNativeModalRenderer() {
        }
        JSNativeModalRenderer.prototype.render = function (dialog, vcRef) {
            var result;
            switch (dialog.context.dialogType) {
                case sqSingleAngularModal.DROP_IN_TYPE.alert:
                    window.alert(dialog.context.message);
                    result = true;
                    break;
                case sqSingleAngularModal.DROP_IN_TYPE.prompt:
                    result = window.prompt(dialog.context.message, dialog.context.promptDefault);
                    break;
                case sqSingleAngularModal.DROP_IN_TYPE.confirm:
                    result = window.confirm(dialog.context.message);
                    break;
            }
            dialog.destroy = function () {
            };
            if (result === false) {
                dialog.dismiss();
            }
            else {
                dialog.close(result);
            }
            // we need to return ComponentRef<ModalOverlay> but a native dialog does'nt have that
            // so we resolve an empty promise, the user of this renderer should expect that.
            return {};
        };
        return JSNativeModalRenderer;
    }());
    JSNativeModalRenderer.decorators = [
        { type: _angular_core.Injectable },
    ];
    /** @nocollapse */
    JSNativeModalRenderer.ctorParameters = function () { return []; };
    var __extends$1 = (undefined && undefined.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var JSNativePresetBuilder = (function (_super) {
        __extends$1(JSNativePresetBuilder, _super);
        function JSNativePresetBuilder(modal, dialogType) {
            return _super.call(this, { modal: modal, dialogType: dialogType }) || this;
        }
        /**
         * Hook to alter config and return bindings.
         * @param config
         */
        JSNativePresetBuilder.prototype.$$beforeOpen = function (config) {
            return [];
        };
        /**
         * Open a modal window based on the configuration of this config instance.
         * @param viewContainer If set opens the modal inside the supplied viewContainer
         * @returns Promise<DialogRef>
         */
        JSNativePresetBuilder.prototype.open = function (viewContainer) {
            var context = this.toJSON();
            if (!(context.modal instanceof Modal$1)) {
                return Promise.reject(new Error('Configuration Error: modal service not set.'));
            }
            var overlayConfig = {
                context: context,
                renderer: new JSNativeModalRenderer(),
                viewContainer: viewContainer,
                bindings: typeof this.$$beforeOpen === 'function' && this.$$beforeOpen(context)
            };
            return context.modal.open(context.component, overlayConfig);
        };
        return JSNativePresetBuilder;
    }(JSNativeModalContextBuilder));
    var __extends = (undefined && undefined.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var Modal$1 = (function (_super) {
        __extends(Modal$$1, _super);
        function Modal$$1(overlay) {
            return _super.call(this, overlay) || this;
        }
        Modal$$1.prototype.alert = function () {
            return new JSNativePresetBuilder(this, sqSingleAngularModal.DROP_IN_TYPE.alert);
        };
        Modal$$1.prototype.prompt = function () {
            return new JSNativePresetBuilder(this, sqSingleAngularModal.DROP_IN_TYPE.prompt);
        };
        Modal$$1.prototype.confirm = function () {
            return new JSNativePresetBuilder(this, sqSingleAngularModal.DROP_IN_TYPE.confirm);
        };
        Modal$$1.prototype.create = function (dialogRef, type, bindings) {
            return dialogRef;
        };
        return Modal$$1;
    }(sqSingleAngularModal.Modal));
    Modal$1.decorators = [
        { type: _angular_core.Injectable },
    ];
    /** @nocollapse */
    Modal$1.ctorParameters = function () {
        return [
            { type: sqSingleAngularModal.Overlay, },
        ];
    };
    var providers = [
        { provide: sqSingleAngularModal.Modal, useClass: Modal$1 },
        { provide: Modal$1, useClass: Modal$1 }
    ];
    var JSNativeModalModule = (function () {
        function JSNativeModalModule() {
        }
        JSNativeModalModule.getProviders = function () {
            return providers;
        };
        return JSNativeModalModule;
    }());
    JSNativeModalModule.decorators = [
        { type: _angular_core.NgModule, args: [{
                    providers: providers
                },] },
    ];
    /** @nocollapse */
    JSNativeModalModule.ctorParameters = function () { return []; };
    exports.Modal = Modal$1;
    exports.JSNativeModalContext = JSNativeModalContext;
    exports.JSNativeModalContextBuilder = JSNativeModalContextBuilder;
    exports.JSNativeModalRenderer = JSNativeModalRenderer;
    exports.JSNativePresetBuilder = JSNativePresetBuilder;
    exports.JSNativeModalModule = JSNativeModalModule;
    exports.providers = providers;
    Object.defineProperty(exports, '__esModule', { value: true });
})));
